<?php
/**
 * Implement Custom Header functionality
 *
 * @package Catch Themes
 * @subpackage Gridalicious
 * @since Gridalicious 1.0
 */
if ( ! defined( 'GRIDALICIOUS_THEME_VERSION' ) ) {
	header( 'Status: 403 Forbidden' );
	header( 'HTTP/1.1 403 Forbidden' );
	exit();
}


if ( ! function_exists( 'gridalicious_custom_header' ) ) :
/**
 * Implementation of the Custom Header feature
 * Setup the WordPress core custom header feature and default custom headers packaged with the theme.
 *
 * Note that this function is hooked into the after_setup_theme hook, which runs
 * before the init hook. The init hook is too late for some features, such as indicating
 * support post thumbnails.
 */
	function gridalicious_custom_header() {
		/**
		 * Get Theme Options Values
		 */
		$options 	= gridalicious_get_theme_options();

		if ( 'light' == $options['color_scheme'] ) {
			$default_header_color = gridalicious_get_default_theme_options();
			$default_header_color = $default_header_color['header_textcolor'];
		}
		else if ( 'dark' == $options['color_scheme'] ) {
			$default_header_color = gridalicious_default_dark_color_options();
			$default_header_color = $default_header_color['header_textcolor'];
		}

		$args = array(
		// Text color and image (empty to use none).
		'default-text-color'     => $default_header_color,

		// Header image default
		'default-image'			=> trailingslashit( esc_url ( get_template_directory_uri() ) ) . 'images/headers/buddha.jpg',

		// Set height and width, with a maximum value for the width: 21:9
		'height'                 => 514,
		'width'                  => 1200,

		// Support flexible height and width.
		'flex-height'            => true,
		'flex-width'             => true,

		// Random image rotation off by default.
		'random-default'         => false,
	);

	$args = apply_filters( 'custom-header', $args );

	// Add support for custom header
	add_theme_support( 'custom-header', $args );

	}
endif; // gridalicious_custom_header
add_action( 'after_setup_theme', 'gridalicious_custom_header' );


if ( ! function_exists( 'gridalicious_site_branding' ) ) :
	/**
	 * Get the logo and display
	 *
	 * @uses get_transient, gridalicious_get_theme_options, get_header_textcolor, get_bloginfo, set_transient, display_header_text
	 * @get logo from options
	 *
	 * @display logo
	 *
	 * @action
	 *
	 * @since Gridalicious 1.0
	 */
	function gridalicious_site_branding() {
		$options 			= gridalicious_get_theme_options();

		$gridalicious_site_logo = '';
		//Checking Logo
		if ( function_exists( 'has_custom_logo' ) ) {
			if ( has_custom_logo() ) {
				$gridalicious_site_logo = '
				<div id="site-logo">'. get_custom_logo() . '</div><!-- #site-logo -->';
			}
		}
		else if ( '' != $options['logo'] && !$options['logo_disable'] ) {
			$gridalicious_site_logo = '
			<div id="site-logo">
				<a href="' . esc_url( home_url( '/' ) ) . '" title="' . esc_attr( get_bloginfo( 'name', 'display' ) ) . '" rel="home">
					<img src="' . esc_url( $options['logo'] ) . '" alt="' . esc_attr(  $options['logo_alt_text'] ). '">
				</a>
			</div><!-- #site-logo -->';
		}



		$gridalicious_header_text = '
		<div id="site-header">
			<h1 class="site-title"><a href="' . esc_url( home_url( '/' ) ) . '">' . get_bloginfo( 'name' ) . '</a></h1>
			<h2 class="site-description">' . get_bloginfo( 'description' ) . '</h2>
		</div><!-- #site-header -->';


		$text_color = get_header_textcolor();

		$gridalicious_site_branding	= '<div id="site-branding">';
		$gridalicious_site_branding	.= $gridalicious_header_text;

		if ( function_exists( 'has_custom_logo' ) ) {
			if ( has_custom_logo() ) {
				if ( ! $options['move_title_tagline'] && 'blank' != $text_color ) {
					$gridalicious_site_branding  = '<div id="site-branding" class="logo-left">';
					$gridalicious_site_branding .= $gridalicious_site_logo;
					$gridalicious_site_branding .= $gridalicious_header_text;
				}
				else {
					$gridalicious_site_branding  = '<div id="site-branding" class="logo-right">';
					$gridalicious_site_branding .= $gridalicious_header_text;
					$gridalicious_site_branding .= $gridalicious_site_logo;
				}
			}
		}
		else if ( '' != $options['logo'] && !$options['logo_disable'] ) {
			if ( ! $options['move_title_tagline'] && 'blank' != $text_color ) {
				$gridalicious_site_branding  = '<div id="site-branding" class="logo-left">';
				$gridalicious_site_branding .= $gridalicious_site_logo;
				$gridalicious_site_branding .= $gridalicious_header_text;
			}
			else {
				$gridalicious_site_branding  = '<div id="site-branding" class="logo-right">';
				$gridalicious_site_branding .= $gridalicious_header_text;
				$gridalicious_site_branding .= $gridalicious_site_logo;
			}
		}

		$gridalicious_site_branding 	.= '</div><!-- #site-branding-->';

		echo $gridalicious_site_branding ;
	}
endif; // gridalicious_site_branding
add_action( 'gridalicious_header', 'gridalicious_site_branding', 40 );


if ( ! function_exists( 'gridalicious_featured_image' ) ) :
	/**
	 * Template for Featured Header Image from theme options
	 *
	 * To override this in a child theme
	 * simply create your own gridalicious_featured_image(), and that function will be used instead.
	 *
	 * @since Gridalicious 1.0
	 */
	function gridalicious_featured_image() {
		$options				= gridalicious_get_theme_options();

		$header_image 			= get_header_image();

		//Support Random Header Image
		if ( is_random_header_image() ) {
			delete_transient( 'gridalicious_featured_image' );
		}

		if ( !$gridalicious_featured_image = get_transient( 'gridalicious_featured_image' ) ) {

			echo '<!-- refreshing cache -->';

			if ( '' != $header_image  ) {

				// Header Image Link and Target
				if ( !empty( $options['featured_header_image_url'] ) ) {
					//support for qtranslate custom link
					if ( function_exists( 'qtrans_convertURL' ) ) {
						$link = qtrans_convertURL($options['featured_header_image_url']);
					}
					else {
						$link = esc_url( $options['featured_header_image_url'] );
					}
					//Checking Link Target
					if ( !empty( $options['featured_header_image_base'] ) )  {
						$target = '_blank';
					}
					else {
						$target = '_self';
					}
				}
				else {
					$link = '';
					$target = '';
				}

				// Header Image Title/Alt
				if ( !empty( $options['featured_header_image_alt'] ) ) {
					$title = esc_attr( $options['featured_header_image_alt'] );
				}
				else {
					$title = '';
				}

				// Header Image
				$feat_image = '<img class="wp-post-image" alt="' . esc_attr( $title ) . '" src="'.esc_url(  $header_image ).'" />';

				$gridalicious_featured_image = '<div id="header-featured-image">
					<div class="wrapper">';
					// Header Image Link
					if ( !empty( $options['featured_header_image_url'] ) ) :
						$gridalicious_featured_image .= '<a title="'. esc_attr( $title ).'" href="'. esc_url( $link ) .'" target="' . $target . '">' . $feat_image . '</a>';
					else:
						// if empty featured_header_image on theme options, display default
						$gridalicious_featured_image .= $feat_image;
					endif;
				$gridalicious_featured_image .= '</div><!-- .wrapper -->
				</div><!-- #header-featured-image -->';
			}

			set_transient( 'gridalicious_featured_image', $gridalicious_featured_image, 86940 );
		}

		echo $gridalicious_featured_image;

	} // gridalicious_featured_image
endif;


if ( ! function_exists( 'gridalicious_featured_page_post_image' ) ) :
	/**
	 * Template for Featured Header Image from Post and Page
	 *
	 * To override this in a child theme
	 * simply create your own gridalicious_featured_imaage_pagepost(), and that function will be used instead.
	 *
	 * @since Gridalicious 1.0
	 */
	function gridalicious_featured_page_post_image() {
		global $post, $wp_query;

		// Get Page ID outside Loop
		$page_id = $wp_query->get_queried_object_id();
		$page_for_posts = get_option('page_for_posts');

		if ( is_home() && $page_for_posts == $page_id ) {
			$header_page_id = $page_id;
		}
		else {
			$header_page_id = $post->ID;
		}

		if ( has_post_thumbnail( $header_page_id ) ) {
		   	$options					= gridalicious_get_theme_options();
			$featured_header_image_url	= $options['featured_header_image_url'];
			$featured_header_image_base	= $options['featured_header_image_base'];

			if ( '' != $featured_header_image_url ) {
				//support for qtranslate custom link
				if ( function_exists( 'qtrans_convertURL' ) ) {
					$link = qtrans_convertURL( $featured_header_image_url );
				}
				else {
					$link = esc_url( $featured_header_image_url );
				}
				//Checking Link Target
				if ( '1' == $featured_header_image_base ) {
					$target = '_blank';
				}
				else {
					$target = '_self';
				}
			}
			else {
				$link = '';
				$target = '';
			}

			$featured_header_image_alt	= $options['featured_header_image_alt'];
			// Header Image Title/Alt
			if ( '' != $featured_header_image_alt ) {
				$title = esc_attr( $featured_header_image_alt );
			}
			else {
				$title = '';
			}

			$featured_image_size	= $options['featured_image_size'];

			if ( 'featured-header' ==  $featured_image_size ) {
				$feat_image = get_the_post_thumbnail( $post->ID, 'gridalicious-featured-header', array('id' => 'main-feat-img'));
			}
			else if ( 'featured' ==  $featured_image_size ) {
				$feat_image = get_the_post_thumbnail( $post->ID, 'gridalicious-featured', array('id' => 'main-feat-img'));
			}
			else {
				$feat_image = get_the_post_thumbnail( $post->ID, 'gridalicious-featured-grid', array('id' => 'main-feat-img'));
			}

			$gridalicious_featured_image = '<div id="header-featured-image" class =' . $featured_image_size . '>';
				// Header Image Link
				if ( '' != $featured_header_image_url ) :
					$gridalicious_featured_image .= '<a title="'. esc_attr( $title ).'" href="'. esc_url( $link ) .'" target="' . $target . '">' . $feat_image . '</a>';
				else:
					// if empty featured_header_image on theme options, display default
					$gridalicious_featured_image .= $feat_image;
				endif;
			$gridalicious_featured_image .= '</div><!-- #header-featured-image -->';

			echo $gridalicious_featured_image;
		}
		else {
			gridalicious_featured_image();
		}
	} // gridalicious_featured_page_post_image
endif;


if ( ! function_exists( 'gridalicious_featured_overall_image' ) ) :
	/**
	 * Template for Featured Header Image from theme options
	 *
	 * To override this in a child theme
	 * simply create your own gridalicious_featured_pagepost_image(), and that function will be used instead.
	 *
	 * @since Gridalicious 1.0
	 */
	function gridalicious_featured_overall_image() {
		global $post, $wp_query;
		$options				= gridalicious_get_theme_options();
		$enableheaderimage 		= $options['enable_featured_header_image'];

		// Get Page ID outside Loop
		$page_id = $wp_query->get_queried_object_id();

		$page_for_posts = get_option('page_for_posts');

		// Check Enable/Disable header image in Page/Post Meta box
		if ( is_page() || is_single() ) {
			//Individual Page/Post Image Setting
			$individual_featured_image = get_post_meta( $post->ID, 'gridalicious-header-image', true );

			if ( 'disable' == $individual_featured_image  || ( 'default' == $individual_featured_image  && 'disable' == $enableheaderimage  ) ) {
				echo '<!-- Page/Post Disable Header Image -->';
				return;
			}
			elseif ( 'enable' == $individual_featured_image  && 'disabled' == $enableheaderimage  ) {
				gridalicious_featured_page_post_image();
			}
		}

		// Check Homepage
		if ( 'homepage' == $enableheaderimage  ) {
			if ( is_front_page() || ( is_home() && $page_for_posts != $page_id ) ) {
				gridalicious_featured_image();
			}
		}
		// Check Excluding Homepage
		if ( 'exclude-home' == $enableheaderimage  ) {
			if ( is_front_page() || ( is_home() && $page_for_posts != $page_id ) ) {
				return false;
			}
			else {
				gridalicious_featured_image();
			}
		}
		elseif ( 'exclude-home-page-post' == $enableheaderimage  ) {
			if ( is_front_page() || ( is_home() && $page_for_posts != $page_id ) ) {
				return false;
			}
			elseif ( is_page() || is_single() ) {
				gridalicious_featured_page_post_image();
			}
			else {
				gridalicious_featured_image();
			}
		}
		// Check Entire Site
		elseif ( 'entire-site' == $enableheaderimage  ) {
			gridalicious_featured_image();
		}
		// Check Entire Site (Post/Page)
		elseif ( 'entire-site-page-post' == $enableheaderimage  ) {
			if ( is_page() || is_single() ) {
				gridalicious_featured_page_post_image();
			}
			else {
				gridalicious_featured_image();
			}
		}
		// Check Page/Post
		elseif ( 'pages-posts' == $enableheaderimage  ) {
			if ( is_page() || is_single() ) {
				gridalicious_featured_page_post_image();
			}
		}
		else {
			echo '<!-- Disable Header Image -->';
		}
	} // gridalicious_featured_overall_image
endif;


if ( ! function_exists( 'gridalicious_featured_image_display' ) ) :
	/**
	 * Display Featured Header Image
	 *
	 * @since Gridalicious 1.0
	 */
	function gridalicious_featured_image_display() {
		$options = gridalicious_get_theme_options();

		if ( "before-header" == $options['featured_header_image_position']  ) {
			add_action( 'gridalicious_header', 'gridalicious_featured_overall_image', 20 );
		}
		elseif ( "after-grid-content" == $options['featured_header_image_position'] ) {
			add_action( 'gridalicious_before_content', 'gridalicious_featured_overall_image', 20 );
		}
		elseif ( "after-menu" == $options['featured_header_image_position'] ) {
			add_action( 'gridalicious_after_header', 'gridalicious_featured_overall_image', 40 );
		}
		elseif ( "before-menu" == $options['featured_header_image_position'] ) {
			add_action( 'gridalicious_after_header', 'gridalicious_featured_overall_image', 10 );
		}
	} // gridalicious_featured_image_display
endif;
add_action( 'gridalicious_before', 'gridalicious_featured_image_display' );
